// $Id$

/* OVERVIEW
 * 
 * image_context_edit.js
 *  
 * This is mostly cross-browser script for a cropping window
 * To see how it works, click this clown:
 * http://urbits.com/_/demos/insizer_demo_page4.php 
 *
 */
 
 
// vars available set by calling page
// all measurements are pixels as per EDITING WINDOW (not source image)

// imgWidth        - total width
// imgHeight       - total height
// imgOrigWidth        - original height
// imgOrigHeight        - original width
// imgCropWidth    - width of chosen area
// imgCropHeight   - height of chosen area
// imgProportion   - difference b/t editing window and source image ($imgWidth / imgProportion = ORIGINAL)
// imgRatio        - The ration between width and height that must be enforced
// imgContext      - identifies the context (preconfigured height & width found in the config file)
// imgImageID      - identifies the image id for updating the saved information
// imgSavedContextID    - identifies the saved context id for updating the saved information


var browser = new Browser();

// Global object to hold drag information.

var dragObj = new Object();
var maskObj = new Object();
var handleObj = new Object();
  

var xMove;
var yMove;
var currentAction = 'move';

function register(action) {
  currentAction = action;
}


function callDragStart(ev, action) {
  
  dragStart(ev, action);

}

function dragStart(event) {

  var el;
  var x, y;

  dragObj.elNode = $('iz_crop');
  maskObj.Top = $('iz_mT');
  maskObj.Left = $('iz_mL');
  maskObj.Bottom = $('iz_mB');
  maskObj.Right = $('iz_mR');
  handleObj.NE = $('iz_ne');
  handleObj.NW = $('iz_nw');
  handleObj.SE = $('iz_se');
  handleObj.SW = $('iz_sw');

  // Get cursor position with respect to the top left of image 

  if (browser.isIE) {
    x = window.event.clientX + document.documentElement.scrollLeft
      + document.body.scrollLeft;
    y = window.event.clientY + document.documentElement.scrollTop
      + document.body.scrollTop;
  }
  if (browser.isNS) {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
    
  }

  // Save starting positions of cursor and element.

  dragObj.cursorStartX = x;
  dragObj.cursorStartY = y;

  dragObj.elStartLeft  = parseFloat(dragObj.elNode.style.left, 10);
  dragObj.elStartTop   = parseFloat(dragObj.elNode.style.top,  10);

  dragObj.elStartWidth  = parseFloat(dragObj.elNode.style.width, 10);
  dragObj.elStartHeight   = parseFloat(dragObj.elNode.style.height,  10);

//  if (isNaN(dragObj.elStartLeft)) dragObj.elStartLeft = 10;
//  if (isNaN(dragObj.elStartTop))  dragObj.elStartTop  = 10;

  // Capture mousemove and mouseup events on the page.

  if (browser.isIE) {
    document.attachEvent("onmousemove", dragGo);
    document.attachEvent("onmouseup",   dragStop);
    window.event.cancelBubble = true;
    window.event.returnValue = false;
  }
  if (browser.isNS) {
    document.addEventListener("mousemove", dragGo,   true);
    document.addEventListener("mouseup",   dragStop, true);
    event.preventDefault();
  }
}

function dragGo(event) {

  var x, y;

  // Get cursor position with respect to the page.

  if (browser.isIE) {
    x = window.event.clientX + document.documentElement.scrollLeft
      + document.body.scrollLeft;
    y = window.event.clientY + document.documentElement.scrollTop
      + document.body.scrollTop;
  }
  if (browser.isNS) {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
  }

  if (currentAction == 'move') {

    var xMove = (dragObj.elStartLeft + x - dragObj.cursorStartX);
    var yMove = (dragObj.elStartTop  + y - dragObj.cursorStartY);

    if ( xMove <= 0) {
      iLeft = 0;
    } else if ((xMove + imgCropWidth) >= (imgWidth)) {
      iLeft = (imgWidth - imgCropWidth);
    } else {
      iLeft = xMove;
    }
  
    dragObj.elNode.style.left = iLeft + "px";
    maskLeftFix(iLeft);
    maskRightFix(iLeft + imgCropWidth);

    if ( yMove <= 0) {
      iTop = 0;
    } else if ((yMove + imgCropHeight) >= (imgHeight)) {
      iTop = (imgHeight - imgCropHeight);
    } else {
      iTop = yMove;
    }

    dragObj.elNode.style.top = iTop + "px";
    maskTopFix(parseInt(iTop));
    maskBottomFix(iTop + imgCropHeight);

  } else {

    // we are cropping, 
    // first peg back x or y that is out of control.
  //  alert (xMove + " - " + yMove);

    //var perspectiveX = getContextWidthByMouse(xMove, yMove);

//    $(a).value = xMove + " " + dragObj.elStartLeft + x - dragObj.cursorStartX);
//    var yMove = (dragObj.elStartTop + y - dragObj.cursorStartY);

    switch (currentAction) {
      case 'nw':
  
        // NORTH WEST
        // get movement
        var xMove = (dragObj.elStartLeft + x - dragObj.cursorStartX);
        var yMove = (dragObj.elStartTop + y - dragObj.cursorStartY);

        //determine limits
        var xStopAt = 0; var yStopAt = 0;

        if (imgRatio > 0) {
          xStopAt = (dragObj.elStartLeft + dragObj.elStartWidth) - (dragObj.elStartTop + dragObj.elStartHeight) * imgRatio;
          if (xStopAt < 0) {
            xStopAt = 0;
            yStopAt = (dragObj.elStartTop + dragObj.elStartHeight) - ((dragObj.elStartLeft + dragObj.elStartWidth) / imgRatio) ;
          } else {
            yStopAt = 0;
          }
          yMove = (((dragObj.elStartLeft - xMove) / imgRatio) - dragObj.elStartTop) * (-1);
        }


        if (yMove <= yStopAt) {
          iTop = yStopAt;
        } else if (yMove >= (dragObj.elStartTop + dragObj.elStartHeight - imgCropMin)) {
          iTop = (dragObj.elStartTop + dragObj.elStartHeight - imgCropMin);
        } else {
          iTop = yMove;
        }
  
        dragObj.elNode.style.top = iTop + "px";
        imgCropHeight = (dragObj.elStartTop + dragObj.elStartHeight - iTop);
        dragObj.elNode.style.height = imgCropHeight + "px";
        maskTopFix(iTop);

        if (xMove <= xStopAt) {
          iLeft = xStopAt;
        } else if (xMove >= (dragObj.elStartLeft + dragObj.elStartWidth - imgCropMin)) {
          iLeft = (dragObj.elStartLeft + dragObj.elStartWidth - imgCropMin);
        } else {
          iLeft = xMove;
        }
  
        dragObj.elNode.style.left = iLeft + "px";
        imgCropWidth = (dragObj.elStartLeft + dragObj.elStartWidth - iLeft);
        dragObj.elNode.style.width = imgCropWidth + "px";
        maskLeftFix(iLeft);

        break;      
  
      case 'ne':

          var xMove = (dragObj.elStartLeft + dragObj.elStartWidth + x - dragObj.cursorStartX);
          var yMove = (dragObj.elStartTop + y - dragObj.cursorStartY);

          //determine limits
          var xStopAt = imgWidth; var yStopAt = 0;
  
          if (imgRatio > 0) {
            xStopAt = ((dragObj.elStartTop + dragObj.elStartHeight) * imgRatio) + dragObj.elStartLeft; 
            if (xStopAt > imgWidth) {
              xStopAt = imgWidth;
              yStopAt = (dragObj.elStartTop + dragObj.elStartHeight) - ((imgWidth - dragObj.elStartLeft) / imgRatio) ;
            } else {
              yStopAt = 0;
            }
            xMove = (((dragObj.elStartTop + dragObj.elStartHeight) - yMove) * imgRatio);
          }

    
            if ((xMove + dragObj.elStartLeft) >= xStopAt) {
              iRight = xStopAt;
            } else if ((xMove + dragObj.elStartLeft) <= dragObj.elStartLeft + imgCropMin) {
              iRight = dragObj.elStartLeft + imgCropMin;
            } else {
              iRight = xMove + dragObj.elStartLeft;
            }
      
            imgCropWidth = (iRight - dragObj.elStartLeft);
            dragObj.elNode.style.width = imgCropWidth + "px";
            maskRightFix(iRight);
    
            if (yMove <= yStopAt) {
              iTop = yStopAt;
            } else if (yMove >= (dragObj.elStartTop + dragObj.elStartHeight - imgCropMin)) {
              iTop = (dragObj.elStartTop + dragObj.elStartHeight - imgCropMin);
            } else {
              iTop = yMove;
            }
      
            dragObj.elNode.style.top = iTop + "px";
            imgCropHeight = (dragObj.elStartTop + dragObj.elStartHeight - iTop);
            dragObj.elNode.style.height = imgCropHeight + "px";
            maskTopFix(iTop);
            
            break;     
      case 'se':

          var xMove = (dragObj.elStartLeft + dragObj.elStartWidth + x - dragObj.cursorStartX);
          var yMove = (dragObj.elStartTop  + dragObj.elStartHeight + y - dragObj.cursorStartY);

          //determine limits
          xStopAt = imgWidth; var yStopAt = imgHeight;
          if (imgRatio > 0) {
            xStopAt = ((imgHeight - dragObj.elStartTop) * imgRatio) + dragObj.elStartLeft; 
            if (xStopAt > imgWidth) {
              xStopAt = imgWidth;
              yStopAt = (dragObj.elStartTop) + ((imgWidth - dragObj.elStartLeft) / imgRatio) ;
            } else {
              yStopAt = imgHeight;
            }
            yMove = (((dragObj.elStartLeft - xMove) / imgRatio) - dragObj.elStartTop) * (-1);
          }

  
          var iBottom;
          if ((yMove) >= yStopAt) {
            iBottom = yStopAt;
          } else if ((yMove) <= dragObj.elStartTop + imgCropMin) {
            iBottom = dragObj.elStartTop + imgCropMin;
          } else {
            iBottom = yMove;
          }
    
          var iRight;
          imgCropHeight = (iBottom - dragObj.elStartTop);
          dragObj.elNode.style.height = imgCropHeight + "px";
          maskBottomFix(iBottom);
  
          if ((xMove) >= xStopAt) {
            iRight = xStopAt;
          } else if ((xMove) <= dragObj.elStartLeft + imgCropMin) {
            iRight = dragObj.elStartLeft + imgCropMin;
          } else {
            iRight = xMove;
          }
    
          imgCropWidth = (iRight - dragObj.elStartLeft);
          dragObj.elNode.style.width = imgCropWidth + "px";
          maskRightFix(iRight);
  
          break;

     case 'sw':

        var xMove = (dragObj.elStartLeft + x - dragObj.cursorStartX);
        var yMove = (dragObj.elStartTop  + dragObj.elStartHeight + y - dragObj.cursorStartY);

        //determine limits
        var xStopAt = 0; var yStopAt = imgHeight;
        if (imgRatio > 0) {
          var xStopAt = (dragObj.elStartLeft + dragObj.elStartWidth) - ((imgHeight - dragObj.elStartTop) * imgRatio); 
          if (xStopAt < 0) {
            xStopAt = 0;
            yStopAt = ((dragObj.elStartLeft + dragObj.elStartWidth) / imgRatio) + dragObj.elStartTop;
          } else {
            yStopAt = imgHeight;
          }
          xMove = ((((yMove - dragObj.elStartTop) * imgRatio) - (dragObj.elStartLeft + dragObj.elStartWidth)) * (-1));
        }

        
        if ((yMove) >= yStopAt) {
          iBottom = yStopAt;
        } else if (yMove <= dragObj.elStartTop + imgCropMin) {
          iBottom = dragObj.elStartTop + imgCropMin;
        } else {
          iBottom = yMove;
        }
        
        imgCropHeight = (iBottom - dragObj.elStartTop);
        dragObj.elNode.style.height = imgCropHeight + "px";
        maskBottomFix(iBottom);
        
        if (xMove <= xStopAt) {
          iLeft = xStopAt;
        } else if (xMove >= (dragObj.elStartLeft + dragObj.elStartWidth - imgCropMin)) {
          iLeft = (dragObj.elStartLeft + dragObj.elStartWidth - imgCropMin);
        } else {
          iLeft = xMove;
        }
        
        dragObj.elNode.style.left = iLeft + "px";
        imgCropWidth = (dragObj.elStartLeft + dragObj.elStartWidth - iLeft);
        dragObj.elNode.style.width = imgCropWidth + "px";
        maskLeftFix(iLeft);
        break;     
    }

  }

  if (browser.isIE) {
    window.event.cancelBubble = true;
    window.event.returnValue = false;
  }
  if (browser.isNS)
    event.preventDefault();
}

function dragStop(event) {

  // Stop capturing mousemove and mouseup events.
  currentAction = 'move';
  
  if (browser.isIE) {
    document.detachEvent("onmousemove", dragGo);
    document.detachEvent("onmouseup",   dragStop);
  }
  if (browser.isNS) {
    document.removeEventListener("mousemove", dragGo,   true);
    document.removeEventListener("mouseup",   dragStop, true);
  }
  dragObj.elStartLeft  = parseFloat(dragObj.elNode.style.left, 10);
  dragObj.elStartTop   = parseFloat(dragObj.elNode.style.top,  10);

  dragObj.elStartWidth  = parseFloat(dragObj.elNode.style.width, 10);
  dragObj.elStartHeight   = parseFloat(dragObj.elNode.style.height,  10);

  var $retA = dragObj.elStartLeft / imgProportion;
  var $retX = (dragObj.elStartLeft +  dragObj.elStartWidth ) / imgProportion;
  var $retB = dragObj.elStartTop / imgProportion;
  var $retY = (dragObj.elStartTop + dragObj.elStartHeight ) / imgProportion;

  if ($retA-2>0)              {$("textA").value = $retA;} else {$("textA").value =-1;}
//  $("textX").value = $retX + " " + imgDBWidth;
  if ($retX+1<imgDBWidth)     {$("textX").value = $retX;} else {$("textX").value =-1;}
  if ($retB-2>0)              {$("textB").value = $retB;} else {$("textB").value =-1;}
  if ($retY+1<imgDBHeight)    {$("textY").value = $retY;} else {$("textY").value =-1;}

}

function maskLeftFix(boundary, crop) {
 
  maskObj.Left.style.width = boundary + "px";
  maskObj.Top.style.left = boundary + "px";
  maskObj.Top.style.width = (imgWidth - boundary) + "px";
  handleObj.NE.style.left = (imgCropWidth - 4) + "px";
  handleObj.SE.style.left = (imgCropWidth - 4) + "px";
}
  
function maskRightFix(boundary, crop) {
  
  maskObj.Right.style.left = boundary + "px";
  maskObj.Right.style.width = (imgWidth - boundary) + "px";
  maskObj.Bottom.style.width = boundary + "px";
  handleObj.NE.style.left = (imgCropWidth - 4)+ "px";
  handleObj.SE.style.left = (imgCropWidth - 4) + "px";
}
   
function maskTopFix(boundary, crop) {
  
  maskObj.Top.style.height = boundary + "px";
  maskObj.Right.style.top = boundary + "px";
  maskObj.Right.style.height = (imgHeight - boundary) + "px";
  handleObj.SW.style.top = (imgCropHeight - 4) + "px";
  handleObj.SE.style.top = (imgCropHeight - 4) + "px";
}
  
function maskBottomFix(boundary, crop) {
  
  maskObj.Bottom.style.top = boundary + "px";
  maskObj.Bottom.style.height = (imgHeight - boundary) + "px";
  maskObj.Left.style.height = boundary + "px";
  handleObj.SW.style.top = (imgCropHeight - 4) + "px";
  handleObj.SE.style.top = (imgCropHeight - 4) + "px";
}

function getContextWidthByMouse(kX, kY) {
 
  var a1 = (Math.atan(imgOrigHeight/imgOrigWidth) * (180 / Math.PI));
//  alert("a1 = " + a1);
  var a2 = 90 - a1;
//  alert("a2 = " + a2);
  var a3 = (Math.atan(kY/kX) * (180 / Math.PI))
//  alert("a3 = " + a3);
  var a4 = a3 - a2;
//  alert("a4 = " + a4);
  var k3 = Math.sqrt(Math.pow(kX,2)+Math.pow(kY,2));
//  alert("k3 = " + k3);
  var k6 = Math.sin(a4 / (180 / Math.PI)) * k3;
//  alert("k6 = " + k6);
  var finalx =  Math.cos(a1) * k6; 
  return finalx;
  
}
